# Copyright (c) 2013 Shotgun Software Inc.
#
# CONFIDENTIAL AND PROPRIETARY
#
# This work is provided "AS IS" and subject to the Shotgun Pipeline Toolkit
# Source Code License included in this distribution package. See LICENSE.
# By accessing, using, copying or modifying this work you indicate your
# agreement to the Shotgun Pipeline Toolkit Source Code License. All rights
# not expressly granted therein are reserved by Shotgun Software Inc.

# Metadata defining the behaviour and requirements for this app

# expected fields in the configuration file for this app
configuration:
    # tank write nodes paths
    write_nodes:
        type: list
        description: "A list of dictionaries in which you define the Flow Production Tracking
                     Write nodes that are supported in this configuration. Each dictionary entry
                     needs to have the following keys: 'name' - a descriptive name for this node.
                     'file_type' - the file type to use for the renders (exr, cin, dpx etc).
                     This will be passed to the Nuke write node when rendering. 'settings' -
                     configuration settings for the given file type, as a dictionary. This too
                     will be passed to the write node when rendering. Next, you need two entries
                     named 'render_template' and 'publish_template'
                     - these control the locations where data is written to at various stages
                     of the workflow. These templates need to include the 'version' field
                     and can optionally include the fields 'name', 'width', 'height'
                     (which reflect the image resolution of the render) and 'output' (which
                     differenciates different write nodes). If you are doing stereo
                     rendering and want to use Nuke's %V flag, include an 'eye' field.
                     This will be replaced by %V in the paths when the Flow Production Tracking
                     Write node computes them.  Finally, you need the templates 'proxy_render_template'
                     and 'proxy_publish_template' these have the same requirements as the regular
                     render and pubish templates but are used when rendering in proxy mode.  If
                     these are missing (set to null) then the regular templates will be used
                     instead."
        allows_empty: True
        values:
            type: dict
            items:
                name:
                    type: str
                file_type:
                    type: str
                file_extension:
                    type: str
                    description:
                        "The file extension to use if it doesnt match the file_type.
                        For example, file_type 'targa' would need to have the
                        extension be 'tga' or else the extenstion will be incorrect."
                settings:
                    type: dict
                tank_type:
                    type: tank_type
                render_template:
                    type: template
                    fields: context, version, [SEQ], [name], [width], [height], [view], *
                publish_template:
                    type: template
                    fields: context, version, [SEQ], [name], [width], [height], [view], *
                proxy_render_template:
                    type: template
                    fields: context, version, [SEQ], [name], [width], [height], [view], *
                    allows_empty: True
                    default_value: null
                proxy_publish_template:
                    type: template
                    fields: context, version, [SEQ], [name], [width], [height], [view], *
                    allows_empty: True
                    default_value: null
                tile_color:
                    type: list
                    values:
                        type: int
                    description:
                        "Specify a list of 3 values in the range 0-255 that represent the RGB values to be
                        set for the node background/tile_color in the node graph when this profile is used.
                        Specify an empty list to use the default colour."
                    allows_empty: True
                    default_value: []
                promote_write_knobs:
                    type: list
                    values:
                        type: str
                    description:
                        "Specify a list of knob names that should be promoted from the internal write node
                        up to the user interface of the gizmo."
                    allows_empty: True
                    default_value: []

    # Note that if you have presets which promote write knobs, the convert menu items will not be shown, regardless
    # of the value applied to this setting, as at present the convert back method doesn't support promoted knobs.
    show_convert_actions:
        type: bool
        description: "Setting this to True will add actions for converting to and from Flow Production Tracking
                      write nodes. The actions will be displayed as options in the
                      Flow Production Tracking -> Context menu"
        default_value: False

    template_script_work:
        type: template
        description:
            "A reference to a template which locates a nuke script work file on disk. This
            is used to drive the version and optionally the name of renders."
        fields: context, version, [name], *

    image_categories:
        type: list
        values:
            type: str
        description: "Specify a list of image categories to use as a bucket for rendered images in the images folder."
        allows_empty: False
        default_value: [comp, precomp]

# the Shotgun fields that this app needs in order to operate correctly
requires_shotgun_fields:

# More verbose description of this item
display_name: "Write Node"
description: "Support for the Flow Production Tracking Write Node in Nuke."

# Required minimum versions for this item to run
requires_shotgun_version:
requires_core_version: "v0.19.8"
requires_engine_version: "v0.2.3"

# the engines that this app can operate in:
supported_engines: [tk-nuke]

# the frameworks required to run this app
frameworks:
    - { "name": "tk-framework-nx", "version": "v1.x.x" }
